<template>

  <v-container fluid>

    <v-card-actions>
      <v-spacer />
      <v-text-field
        name="Alumno-text" label="Búsqueda" v-model="alumnos.tabla.busqueda"
        style="border-radius: 10px; max-width: 300px;" clearable dense
        prepend-inner-icon="mdi-account-search" outlined color="white"
      />
    </v-card-actions>

    <v-card>

      <v-data-table
        :headers="alumnos.tabla.headers" :items="alumnos.listado" class="elevation-0"
        hide-default-footer :items-per-page="alumnos.tabla.alumnosPorPagina"
        :page.sync="alumnos.tabla.pagina" @page-count="alumnos.tabla.conteoPaginas = $event"
        :loading="alumnos.tabla.loading" :custom-filter="Busqueda" :search="alumnos.tabla.busqueda"
        loading-text="Cargando... por favor espere"
      >

        <template v-slot:no-data>

          <v-alert prominent type="info" color="blue darken-1">
            No hay alumnos disponibles para mostrar en este momento, vuelva a intentarlo.
          </v-alert>

        </template>

        <template v-slot:no-results>

          <v-alert prominent type="info" color="blue darken-1">
            No hay resultados encontrados con la búsqueda "{{ alumnos.tabla.busqueda }}".
          </v-alert>

        </template>

        <template v-slot:top>

          <v-toolbar height="80" flat style="border-radius: 10px;">
            <v-toolbar-title>
              Administrar Alumnos
            </v-toolbar-title>
            <v-spacer />
            <v-btn color="blue darken-1" @click="MostrarDialogoNuevoAlumno">
              <v-icon left size="25">mdi-plus</v-icon>
              Nuevo Alumno
            </v-btn>
          </v-toolbar>

        </template>

        <template v-slot:[`item.fechaNacimiento`] = "{ item }">

          <span> {{ [ item.fechaNacimiento, "YYYY-MM-DD" ] | moment("DD/MM/YYYY") }} </span>

        </template>

        <template v-slot:[`item.grado`] = "{ item }">

          <span> {{ item.alumno_grado ? item.alumno_grado.grado.nombre + ', sección: ' + item.alumno_grado.seccion : 'Grado no asignado'  }} </span>

        </template>

        <template v-slot:[`item.acciones`] = "{ item }">

          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="amber darken-1" dark v-bind="attrs" v-on="on"
                @click="MostrarDialogoEditarAlumno(item)" icon
              >

                <v-icon> mdi-pencil </v-icon>

              </v-btn>
            </template>
            <span>Editar Alumno</span>
          </v-tooltip>

          <v-tooltip bottom v-if="!item.alumno_grado">
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="green" dark v-bind="attrs" v-on="on"
                @click="MostrarDialogoAsignarGrado(item)" icon
              >

                <v-icon> mdi-billboard </v-icon>

              </v-btn>
            </template>
            <span>Asignar Grado</span>
          </v-tooltip>

          <v-tooltip bottom v-if="item.alumno_grado">
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="error" dark v-bind="attrs" v-on="on"
                @click="DesasignarGrado(item)" icon
              >

                <v-icon> mdi-clipboard-off </v-icon>

              </v-btn>
            </template>
            <span>Desasignar Grado</span>
          </v-tooltip>

          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="error" dark v-bind="attrs" v-on="on"
                @click="EliminarAlumno(item)" icon
              >

                <v-icon> mdi-delete </v-icon>

              </v-btn>
            </template>
            <span>Eliminar Alumno</span>
          </v-tooltip>

        </template>

      </v-data-table>

      <v-divider/>

      <v-pagination
        class="py-3" v-model="alumnos.tabla.pagina"
        :length="alumnos.tabla.conteoPaginas" total-visible="10"
      >

      </v-pagination>

    </v-card>

    <NuevoEditarAlumno
      v-model="dialogos.alumno" :alumno.sync="alumnos.seleccionado"
      @refresh="ObtenerAlumnos"
    />

    <AsignarGrado
      v-model="dialogos.asignar_grado" :alumno.sync="alumnos.seleccionado"
      :grados="grados" @refresh="ObtenerAlumnos"
    />

  </v-container>

</template>


<script>

import NuevoEditarAlumno from "~/components/alumnos/NuevoEditarAlumno";
import AsignarGrado from "~/components/alumnos/AsignarGrado";

export default {

  components: { AsignarGrado, NuevoEditarAlumno },

  mounted() {

    this.ObtenerAlumnos()

  },

  data(){

    return {

      dialogos: {

        alumno: false,
        asignar_grado: false

      },

      alumnos: {

        listado: [],
        seleccionado: {},
        tabla: {

          headers: [
            { text: 'ID', value: 'idAlumno', align: 'center' },
            { text: 'Nombre', value: 'nombre', align: 'center' },
            { text: 'Apellido', value: 'apellidos', align: 'center' },
            { text: 'Grado', value: 'grado', align: 'center' },
            { text: 'Fecha de Nacimiento', value: 'fechaNacimiento', align: 'center' },
            { text: 'Acciones', value: 'acciones', align: 'center' },
          ],
          busqueda: null,
          loading: false,
          pagina: 1,
          conteoPaginas: 0,
          alumnosPorPagina: 10

        }

      },

      grados: []

    }

  },

  methods: {

    async ObtenerAlumnos(){

      this.alumnos.tabla.loading = true

      let config = { timeout: 5000 }

      await this.$axios.get("/alumnos", config).then(({data}) => {

        this.alumnos.listado = data
        this.alumnos.tabla.loading = false

      })

    },

    async ObtenerGrados(){

      let config = { timeout: 5000 }

      await this.$axios.get("/grados", config).then(({data}) => {

        this.grados = data

      })

    },

    async EliminarAlumno(alumno){

      let config = { timeout: 5000 }

      await this.$axios.post("/alumnos/eliminar/" + alumno.idAlumno, {}, config).then(({data}) => {

        this.ObtenerAlumnos()

      })

    },

    async DesasignarGrado(alumno){

      let config = { timeout: 5000 }

      await this.$axios.post("/alumnos/desasignar-grado", alumno.alumno_grado, config).then(({data}) => {

        this.ObtenerAlumnos()

      })

    },

    Busqueda(value, search, item){

      let nombre = RegExp(search, 'i').test(item.nombre)
      let apellidos = RegExp(search, 'i').test(item.apellidos)

      return nombre | apellidos

    },

    MostrarDialogoNuevoAlumno(){

      this.dialogos.alumno = true

    },

    MostrarDialogoEditarAlumno(alumno){

      this.alumnos.seleccionado = Object.assign({}, alumno)
      this.dialogos.alumno = true

    },

    MostrarDialogoAsignarGrado(alumno){

      this.alumnos.seleccionado = Object.assign({}, alumno)
      this.ObtenerGrados()
      this.dialogos.asignar_grado = true

    }

  }

}

</script>
